require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

Mission = {
	destroyUnits = 1,
	destroyDepot = 2
}

function onGameStart()
	--print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:createMission(Mission.destroyUnits, 		true,	Text.T_MULTIPLAYER_GOAL_DESTROYALL);
	ScriptManager:createMission(Mission.destroyDepot, 		true,	Text.T_MULTIPLAYER_GOAL_DESTROYBASE);
	
	ScriptManager:setMissionStatus(Mission.destroyUnits, 	MissionStatus.IN_PROGRESS);
	ScriptManager:setMissionStatus(Mission.destroyDepot,	MissionStatus.IN_PROGRESS);
end