require "lua/UnitFunctions"
require "lua/Functions_2"
require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

EnemyUnit={
	18, 16, 15, 15,	17, 26
}

EnemyUnitX={
	8, 9, 7, 8,	9, 7,
	3, 4, 5, 6, 3, 4
}

EnemyUnitY={
	0,
	16
}

EnemyUnitMoveX={
	0,-1,-1,-2,-2,-1,-2,0,0,1,2,3
}

EnemyUnitMoveY={
	-1,0,-2,0,-1,-1,-2,-2, 3,3,3,3
}

function startCutscene()
	--ScriptManager:startCutscene();
	situation = 1
	goalNo = 1
	j = 0
	ScriptManager:sleep( 1, "spawnEnemy");
end

function spawnEnemy()
	--print("spawn it")
	--print("j:"..j%(#EnemyUnit*2))
	
	local this_unit = EnemyUnit[(j%#EnemyUnit)+1];
	local posX = EnemyUnitX[(j%#EnemyUnitX)+1];
	local posY = EnemyUnitY[(situation%2)+1];
	
	newunit = ScriptManager:spawnUnit( 1, this_unit, posX, posY, 1, AiState.WAIT );
	j = j+1;
	
	if j%((#EnemyUnit*2)+1)== (#EnemyUnit*2) then
		situation = situation + 1;
	end
	if j%((#EnemyUnit)+1)== (#EnemyUnit) then
		goalNo = goalNo+1;
		print("goal:"..goalNo)
	end
	
	goal = Unit:getUnitById(Depots[5-goalNo]);
	print("DepotX:"..goal:getX().."/DepotY:"..goal:getY());
	tryMove = 1
	print("posX:"..posX.."/posY:"..posY);
	MoveTowardsGoal(EnemyUnitMoveX[tryMove],EnemyUnitMoveY[tryMove])
end

function MoveTowardsGoal(xMod, yMod)
	if(goal:getX()>=newunit:getX()) then
		xMod = xMod*-1
	end
	
 	if(goal:getY()>=newunit:getY()) then
		yMod = yMod*-1
	end
	
	print("xMod:"..xMod.."/yMod:"..yMod);
	
	goalX = newunit:getX()+xMod;
	goalY = newunit:getY()+yMod;
	
	print("goalX:"..goalX.."/goalY:"..goalY);
	if getFreeTile()== true then
		ScriptManager:moveUnit( newunit:getId(), goalX, goalY, "")
	end
	tryMove = tryMove+1;
	ScriptManager:sleep( 0.1, "checkMove");
	
end

function getFreeTile()
	if Unit:getUnitAt(goalX,goalY) == nil then
		return true
	end
end

function checkMove()
	if tryMove < #EnemyUnitMoveX+1  and newunit:getX() == goalX and newunit:getY() == goalY then
		print("Move Again"..tryMove);
		MoveTowardsGoal(EnemyUnitMoveX[tryMove],EnemyUnitMoveY[tryMove])
	elseif j < (#EnemyUnit)*4then
		ScriptManager:sleep( 0.1, "spawnEnemy");
	end
end
--[[
function spawnTank2()
	local unit = ScriptManager:spawnUnit( 0, 2, 3, 6, 1, AiState.WAIT );
	ScriptManager:moveUnit( unit:getId(), 3, 1, "" );
end

function showDepot1()
	ScriptManager:displaySubtitle( "We need to establish a base" );
	posX = 9;
	posY = 3;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 6, "showDepot2" );
end

function showDepot2()
	ScriptManager:displaySubtitle( "There are a lot of Depots here" );
	posX = 4;
	posY = 14;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 6, "showBunker" );
end

function showBunker()
	ScriptManager:displaySubtitle( "This Bunker could come in handy to fortify our position" );
	posX = 7;
	posY = 8;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 5, "removeDepotMarker");
end

function markEnemyDepot()
	ScriptManager:showMarkerAt( posX, posY );
end

function removeDepotMarker()
	ScriptManager:dismissSubtitle();
	--ScriptManager:sleep( 2, "removeDepotMarker");
	ScriptManager:removeAllMarkers();
	ScriptManager:moveCamera( 2, 2, 0.7 ,3, "endCutscene" );
end

function endCutscene()
	ScriptManager:stopCutscene();
	ScriptManager:setMissionStatus(Mission.MAIN, MissionStatus.IN_PROGRESS);
	ScriptManager:setMissionStatus(Mission.SECONDARY, MissionStatus.IN_PROGRESS);
end
]]
--END Intro cutscene

