require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

function onGameStart()
	print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:createMission(0,true,Text.T_MISSION_MAP_1_3_INTRO_MISSION_MAIN)
	ScriptManager:setMissionXp(0,2000)
	
	ScriptManager:createMission(1,true,Text.T_MISSION_MAP_1_3_INTRO_MISSION_SECONDARY)
	ScriptManager:setMissionXp(1,1000)
	
	ScriptManager:createMission(2,false,Text.T_MISSION_MAP_1_3_INTRO_MISSION_SECONDARY)
	ScriptManager:setMissionXp(2,500)
		
	ScriptManager:sleep(3,"setupMissions")
end

function setupMissions()
	ScriptManager:setMissionStatus(0,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionStatus(1,MissionStatus.IN_PROGRESS)
	ScriptManager:setMissionStatus(2,MissionStatus.IN_PROGRESS)
		
	ScriptManager:sleep(5,"firstWon")
end

function firstWon()
	ScriptManager:setMissionStatus(0,MissionStatus.ACCOMPLISHED)
		
	ScriptManager:sleep(5,"secondFailed")
end

function secondFailed()
	ScriptManager:setMissionStatus(2,MissionStatus.FAILED)
		
	ScriptManager:sleep(5,"lastWon")
end

function lastWon()
	ScriptManager:setMissionStatus(1,MissionStatus.ACCOMPLISHED)
	ScriptManager:displaySubtitle("Mission Accomplished!")
	ScriptManager:moveCamera(5,12,0.5,5,"endGame")
end

function endGame()
	ScriptManager:endGame()
end