require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

Mission = {
	MAIN = 1
}

function onGameStart()
	--print(string.format("[SCRIPT] onGameStart()..."));
	ScriptManager:createMission(Mission.MAIN, true, Text.T_MISSION_VICTORY);
	ScriptManager:setMissionXp(1,100000);
	ScriptManager:setMissionStatus(Mission.MAIN, MissionStatus.IN_PROGRESS);
	ScriptManager:sleep(3,"start");
end

function start()
	ScriptManager:setMissionStatus(Mission.MAIN, MissionStatus.ACCOMPLISHED);
	ScriptManager:sleep(3,"endMission")
end

function endMission()
	ScriptManager:endGame();
end