require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

Mission = {
	MAIN = 1
}

function onGameStart()
	ScriptManager:createMission(Mission.MAIN, true, Text.T_MULTIPLAYER_GOAL_DESTROYALL);
	ScriptManager:setMissionStatus(Mission.MAIN, MissionStatus.IN_PROGRESS);
	setTriggers()
	ScriptManager:setGuardArea(1,1,2,11,1)
end
function setTriggers()
	ScriptManager:addOnTurnEndTrigger( 1, -1, -1, "onEnemyTurnStart", "onEnemyTurnStart", false );-- when the AI start their turn spawn unit
end

function onEnemyTurnStart()
	
	print(ScriptManager:getCurrentTurn())
	if ScriptManager:getCurrentTurn()==3 then -- on the first turn play a cutscene that describs the enymy spawning
	ScriptManager:setGuardArea(1,1,2,3,1)
	elseif ScriptManager:getCurrentTurn()==13 then
	ScriptManager:setGuardArea(1,1,12,4,3)
	elseif ScriptManager:getCurrentTurn()==23 then
            ScriptManager:setGuardArea(1,1,12,11,2)
	elseif ScriptManager:getCurrentTurn()==33 then
            ScriptManager:setGuardArea(1,1,2,11,1)
	end
end