require "lua/UnitFunctions"
require "lua/Functions_2"
require "lua/Constants"
require "lua/Functions"
require "lua/Text"
require "lua/Units"
require "math"

function startIntro()
	ScriptManager:startCutscene();
	ScriptManager:sleep( 1, "showDepot1");
end

function showDepot1()
	ScriptManager:displaySubtitle( "We need to establish a base" );
	posX = 9;
	posY = 3;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 6, "showDepot2" );
end

function showDepot2()
	ScriptManager:displaySubtitle( "There are a lot of Depots here" );
	posX = 4;
	posY = 14;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 6, "showBunker" );
end

function showBunker()
	ScriptManager:displaySubtitle( "This Bunker could come in handy to fortify our position" );
	posX = 7;
	posY = 8;
	ScriptManager:moveCamera( posX, posY, 0.7, 2, "markEnemyDepot" );
	markEnemyDepot();
	ScriptManager:sleep( 5, "removeDepotMarker");
end

function markEnemyDepot()
	ScriptManager:showMarkerAt( posX, posY );
end

function removeDepotMarker()
	ScriptManager:dismissSubtitle();
	--ScriptManager:sleep( 2, "removeDepotMarker");
	ScriptManager:removeAllMarkers();
	ScriptManager:moveCamera( 2, 2, 0.7 ,3, "endCutscene" );
end

function endCutscene()
	ScriptManager:stopCutscene();
	ScriptManager:setMissionStatus(Mission.MAIN, MissionStatus.IN_PROGRESS);
	ScriptManager:setMissionStatus(Mission.SECONDARY, MissionStatus.IN_PROGRESS);
end

--END Intro cutscene